

import 'Vector2.dart';

double approximateDistance(Vector2 a, Vector2 b){
  return approximateLength(a.x - b.x, a.y - b.y);
}

double approximateLength(num a, num b){
  const squareRatio = 0.70710656237;
  const inverseRatio = 1.0 - squareRatio;
  const _1 = 1.0;

  final aAbs = a.abs();
  final bAbs = b.abs();

  late final long;
  late final short;

  if (aAbs > bAbs) {
    long = aAbs;
    short = bAbs;
  } else {
    long = bAbs;
    short = aAbs;
  }
  final ratio = short / long;
  final longRatio = _1 - (ratio * inverseRatio);
  return long / longRatio;
}

void insertionSort<E>({
  required List<E> list,
  required int Function(E, E) compare,
  int start = 0,
  required int end
}) {
  for (var pos = start + 1; pos < end; pos++) {
    var min = start;
    var max = pos;
    var element = list[pos];
    while (min < max) {
      var mid = min + ((max - min) >> 1);
      var comparison = compare(element, list[mid]);
      if (comparison < 0) {
        max = mid;
      } else {
        min = mid + 1;
      }
    }
    list.setRange(min + 1, pos + 1, list, min);
    list[min] = element;
  }
}
